;**************************************************************************
;*
;* FILE  ld2_zp_bss.asm
;* Copyright (c) 2008 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: ld2_zp_bss.asm,v 1.9 2009-03-30 08:31:37 tlr Exp $
;*
;* DESCRIPTION
;*   Loader II zp and bss
;*
;******
	include	"macros.i"
;	INFO	"--- start of file ld2_zp_bss.asm ---"		

; configuration
BUFFER_BASE	equ	$1e0000	
;BUFFER_BASE	equ	$004000	
BUFFER_SEGMENT	equ	BUFFER_BASE >> 14
DMABLIT_OFFSET	equ	BUFFER_BASE-start_buffers

;**************************************************************************
;*
;* SECTION  buffer space for raw disk reads.
;*
;******
	seg.u	ld2_buffers
	org	$4000
start_buffers:
	align	256
dma_dd00_buffer:
dma_dd00_buffer_real	equ	. + DMABLIT_OFFSET
	ds.b	$2000
	align	256
track_buffer:
track_buffer_real	equ	. + DMABLIT_OFFSET
	ds.b	21*$0100
htab:
	ds.b	256
ltab:
	ds.b	256
read_tab:
	ds.b	21		; MAX_SECTORS

;**************************************************************************
;*
;* SECTION  buffers and state for file access.
;*
;******
	align	256
MAX_FILES	equ	32
DIR_ENTRY_LEN	equ	2+16	; t/s + filename
dir_buffer:
	ds.b	DIR_ENTRY_LEN*MAX_FILES
dir_buffer_end:
DIR_BUFFER_LEN	equ	dir_buffer_end-dir_buffer
	align	256
dir_cnt:
	ds.b	1
last_track:
	ds.b	1
track:
	ds.b	1
sector:
	ds.b	1
offset:
	ds.b	1
load_mode:
	ds.b	1
	
end_buffers:
;	SHOWRANGE "ld2_buffers",start_buffers,end_buffers	

;**************************************************************************
;*
;* SECTION  zero page for raw disk reads
;*
;******
	seg.u	ld2_zp
	org	$40
start_zp:
track_zp:
	ds.b	1
sector_zp:
	ds.b	1
num_zp:
	ds.b	1
ptr_zp:
	ds.w	1
ptr2_frac_zp:
	ds.b	1
ptr2_zp:
	ds.w	1
bank_zp:
	ds.b	1
tmp_zp:
	ds.b	1
chksum_zp:
	ds.b	1
left_zp:
	ds.b	1
shift_zp:
	ds.b	1
err_zp:
	ds.b	1

;**************************************************************************
;*
;* SECTION  zero page for file access
;*
;******
lptr_zp:
	ds.w	1
loadaddr_flag_zp:
	ds.b	1
last_flag_zp:
	ds.b	1
namptr_zp:
	ds.w	1
namlen_zp:
	ds.b	1
tptr_zp:
	ds.b	3
	if	HAVE_COUNT_ADDR
strt_zp:
	ds.b	3
	endif
endoffs_zp:
	ds.b	1
count_zp:
	ds.b	1
	
	
end_zp:
;	SHOWRANGE "ld2_zp",start_zp,end_zp	
; eof
