;**************************************************************************
;*
;* FILE  loader2_test.asm
;* Copyright (c) 2008, 2009 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: loader2_test.asm,v 1.56 2009-04-04 13:07:24 tlr Exp $
;*
;* DESCRIPTION
;*   Test code for Loader II.
;*
;******
	processor 6502

	include	"macros.i"
	INFO	"--- start of file loader2_test.asm ---"		

LOADER2_TEST	equ	1
	include	"loader2_runtime.i"

	seg.u	zp
;**************************************************************************
;*
;* SECTION  zero page
;*
;******
	org	$20
ptr_zp:
	ds.w	1
mptr_zp:
	ds.w	1
mlen_zp:
	ds.b	1
rptr_zp:
	ds.b	3
eptr_zp:
	ds.b	3

	seg	code
	org	$0801
;**************************************************************************
;*
;* Basic line!
;*
;******
StartOfFile:
	dc.w	EndLine
	dc.w	0
	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
EndLine:
	dc.w	0
	
;**************************************************************************
;*
;* SysAddress... When run we will enter here!
;*
;******
SysAddress:
; set device number to 8 if it is less than 8
	lda	#8
	cmp	$ba
	bcc	sa_skp1
	sta	$ba
sa_skp1:

; fix screen
	jsr	$ff5b
	lda	#14
	sta	$d020
	sta	646
	lda	#6
	sta	$d021
	jsr	prepare_system

	lda	#<menu_msg
	ldy	#>menu_msg
	jsr	print
sa_lp1:
	jsr	$ffe4
	cmp	#3
	beq	sa_exit
	cmp	#13
	beq	sa_run
	bra	sa_lp1
sa_exit:
	jmp	sa_ex1

sa_run:	
	ldy	#39
	lda	#$20
sa_lp2:
	sta	($d1),y
	dey
	bpl	sa_lp2

	ldy	#33
sa_lp5:
	lda	#0
	sta	$0400+40*24,y
	lda	646
	sta	$d800+40*24,y
	dey
	bpl	sa_lp5

	lda	#145
	jsr	$ffd2

	jsr	copy_runtime
			
	lda	#0
	jsr	set_irq_amount
	lda	#<install_msg
	ldy	#>install_msg
	jsr	print
	jsr	start_clock
	jsr	ld2_install
 	jsr	stop_clock	
	jsr	print_time
	lda	#13
	jsr	$ffd2
	
	lda	#0
	jsr	set_irq_amount

	lda	#FNAME10K_LEN
	ldx	#<fname10k
	ldy	#>fname10k
	jsr	ld2_setnam_wrap
	jsr	load_file

	jsr	load_file

	lda	#<diskchange_msg
	ldy	#>diskchange_msg
	jsr	print
	jsr	ld2_diskchange
	lda	#<dc_ok_msg
	ldy	#>dc_ok_msg
	jsr	print
	
	lda	#FNAME1KA_LEN
	ldx	#<fname1ka
	ldy	#>fname1ka
	jsr	ld2_setnam_wrap
	jsr	load_file
	lda	#FNAME1KB_LEN
	ldx	#<fname1kb
	ldy	#>fname1kb
	jsr	ld2_setnam_wrap
	jsr	load_file
	lda	#FNAME1KC_LEN
	ldx	#<fname1kc
	ldy	#>fname1kc
	jsr	ld2_setnam_wrap
	jsr	load_file

	lda	#FNAME10K_LEN
	ldx	#<fname10k
	ldy	#>fname10k
	jsr	ld2_setnam_wrap
	jsr	load_file

	lda	#FNAME1KA_LEN
	ldx	#<fname1ka
	ldy	#>fname1ka
	jsr	ld2_setnam_wrap
	jsr	load_file
	lda	#FNAME1KB_LEN
	ldx	#<fname1kb
	ldy	#>fname1kb
	jsr	ld2_setnam_wrap
	jsr	load_file
	lda	#<silence_msg
	ldy	#>silence_msg
	jsr	print
	jsr	ld2_silence	

	jsr	delay1


	lda	#0
	sta	amntcnt
	lda	#FNAME250_LEN
	ldx	#<fname250
	ldy	#>fname250
	jsr	ld2_setnam_wrap

sa_lp3:
	ldx	amntcnt
	lda	amnttab,x
	jsr	set_irq_amount
	jsr	load_file
	inc	amntcnt
	lda	amntcnt
	cmp	#AMNTTAB_LEN
	bne	sa_lp3

	jsr	ld2_silence	
	jsr	ld2_uninstall
	lda	#0
	jsr	set_irq_amount
	lda	#<done_msg
	ldy	#>done_msg
	jsr	print

	lda	$d020
	nopalign 0
sa_lp4:
	eor	#8
	sta	$d020
	bra	sa_lp4
	
sa_ex1:
	jsr	restore_system
	jmp	$a474	

delay1:
	ldx	#0
	ldy	#0
dly1_lp1:
	jsr	dly_twelve
	jsr	dly_twelve
	dex
	bne	dly1_lp1
	dey
	bne	dly1_lp1
dly_twelve:
	rts
amntcnt:
	dc.b	0

amnttab:
	dc.b	0,8,10,12,13	
	dc.b	$20,$40,$60,$80
AMNTTAB_LEN	equ	.-amnttab

fname1ka:
	dc.b	"TEST1KA"
FNAME1KA_LEN	equ	.-fname1ka
fname1kb:
	dc.b	"TEST1KB"
FNAME1KB_LEN	equ	.-fname1kb
fname1kc:
	dc.b	"TEST1KC"
FNAME1KC_LEN	equ	.-fname1kc
fname10k:
	dc.b	"TEST10K"
FNAME10K_LEN	equ	.-fname10k
fname250:
	dc.b	"TEST250"
FNAME250_LEN	equ	.-fname250

menu_msg:
	dc.b	147,"DTV2/3 DMA LOADER II TEST / TLR",13
	dc.b	"----------------------------------------"
	dc.b	13
	dc.b	"INSERT DISK AND PRESS ENTER...",13,145
	dc.b	0
install_msg:
	dc.b	"INSTALLING... ",0
loading_msg:
	dc.b	"LOADING ",0
aeq_msg:
	dc.b	", A=",0
loading2_msg:
	dc.b	"... ",0
ok_msg:
	dc.b	", OK",13,0
loaderr_msg:
	dc.b	", LOADERR!",13,0
csumerr_msg:
	dc.b	", CSUMERR!",13,0
diskchange_msg:
	dc.b	"DISKCHANGE...",0
dc_ok_msg:
	dc.b	"OK",13,0
silence_msg:
	dc.b	"SILENCING...",13,0

done_msg:
	dc.b	"DONE!",0

ld2_setnam_wrap:
	stx	mptr_zp
	sty	mptr_zp+1
	sta	mlen_zp
	jmp	ld2_setnam

load_file:
	lda	#<loading_msg
	ldy	#>loading_msg
	jsr	print
	ldy	#0
ldf_lp1:
	lda	(mptr_zp),y
	jsr	$ffd2
	iny
	cpy	mlen_zp
	bne	ldf_lp1
	lda	#<aeq_msg
	ldy	#>aeq_msg
	jsr	print
	lda	amount
	jsr	print_hex
	
	lda	#<loading2_msg
	ldy	#>loading2_msg
	jsr	print	
	jsr	start_clock
	lda	#LOAD_ADDR2
	jsr	ld2_load

	php
 	jsr	stop_clock	
	jsr	print_time
	plp
	bcs	ldf_load_err
	
	jsr	check_sum	
	bcs	ldf_csum_err
	
	lda	#<ok_msg
	ldy	#>ok_msg
ldf_ex1:
	jmp	print

ldf_load_err:
	lda	#<loaderr_msg
	ldy	#>loaderr_msg
	bne	ldf_ex1
ldf_csum_err:	
	lda	#<csumerr_msg
	ldy	#>csumerr_msg
	bne	ldf_ex1

;**************************************************************************
;*
;* NAME  check_sum
;*
;* DESCRIPTION
;*   Calculate Fletcher8 sum over file.
;*   
;******
sum_a:
	dc.b	0
sum_b:
	dc.b	0
expect_a:
	dc.b	0
expect_b:
	dc.b	0
	
check_sum:
	sei
	sac	#$99
	pha
	lda	#3
	sac	#$00
	ldx	#$1f
	lda	#0
csm_lp1:
	sta	$d300,x
	dex
	bne	csm_lp1
	sta	sum_a
	sta	sum_b
	
	jsr	ld2_getstart
	sta	rptr_zp
	sta	$d300		; Src LSB
	stx	rptr_zp+1
	stx	$d301		; Src MidSB
	sty	rptr_zp+2
	tya
	ora	#$40
	sta	$d302		; Src MSB
	jsr	ld2_getend
	sta	eptr_zp
	stx	eptr_zp+1
	sty	eptr_zp+2

	lda	#<[cgb_sm1+1]
	sta	$d303		; Dest LSB
	lda	#>[cgb_sm1+1]
	sta	$d304		; Dest MidSB
	lda	#$40
	sta	$d305		; Dest MSB
	lda	#1
	sta	$d306		; Src step LSB
	sta	$d30a		; DMA length LSB

	lda	eptr_zp
	sec
	sbc	#2
	sta	eptr_zp
	lda	eptr_zp+1
	sbc	#0
	sta	eptr_zp+1
	lda	eptr_zp+2
	sbc	#0
	sta	eptr_zp+2
	
csm_lp2:
	jsr	cgetb
	clc
	adc	sum_a
	sta	sum_a
	clc
	adc	sum_b
	sta	sum_b
	lda	rptr_zp
	cmp	eptr_zp
	lda	rptr_zp+1
	sbc	eptr_zp+1
	lda	rptr_zp+2
	sbc	eptr_zp+2
	bcc	csm_lp2

	sac	#$99
	pla
	sac	#$00
	cli

	jsr	cgetb
	sta	expect_a
	cmp	sum_a
	bne	csm_fl1
	jsr	cgetb
	sta	expect_b
	cmp	sum_b
	bne	csm_fl1
	clc	
	rts
csm_fl1:
	sec
	rts

; get one byte from source buffer and increment address.
cgetb:
	lda	#%00001101	; Source Dir=pos, Dest Dir=pos, Force Start=1
	sta	$d31f
	inc	rptr_zp
	bne	cgb_skp1
	inc	rptr_zp+1
	bne	cgb_skp1
	inc	rptr_zp+2
cgb_skp1:
	lda	#%00000010
	sta	$d31d		; Src continue
cgb_sm1:
	lda	#0
	rts

;**************************************************************************
;*
;* NAME  print
;*
;* DESCRIPTION
;*   output string
;*   
;******
print:
	sta	ptr_zp
	sty	ptr_zp+1
	ldy	#0
prt_lp1:
	lda	(ptr_zp),y
	beq	prt_ex1
	jsr	$ffd2
	iny
	bne	prt_lp1
	inc	ptr_zp+1
	bne	prt_lp1
prt_ex1:
	rts


;**************************************************************************
;*
;* NAME  print_hex
;*
;* DESCRIPTION
;*   output hex byte.
;*   
;******
print_hex:
	pha
	lsr
	lsr
	lsr
	lsr
	jsr	ph_skp1
	pla
	and	#$0f
ph_skp1:
	clc
	adc	#"0"
	cmp	#"9"+1
	bcc	ph_skp2
	adc	#"A"-("9"+1)-1
ph_skp2:
	jmp	$ffd2

;**************************************************************************
;*
;* NAME  start_clock, stop_clock
;*
;* DESCRIPTION
;*
;******
start_clock:
	sei
	lda	#0
	sta	$dd0e
	sta	$dd0f
	lda	#$7f
	sta	$dd0d
	lda	$dd0d

	ldx	#4
	lda	#$ff
stc_lp1:
	sta	$dd04-1,x
	dex
	bne	stc_lp1
	lda	#%10010001	;continuous count cpu cycles
	sta	$dd0e
	lda	#%01011001	;oneshot count timer A 0's
	sta	$dd0f

	cli
	rts

stop_clock:
	sei
	lda	#%00000000
	sta	$dd0e
	sta	$dd0f		

	ldx	#4
sc_lp1:
	lda	#$ff
	eor	$dd04-1,x
	sta	time-1,x	 
	dex
	bne	sc_lp1
	cli
	rts

time:
 	ds.b	4
	
;**************************************************************************
;*
;* NAME  print_time
;*
;* DESCRIPTION
;*
;******
TIMECONST_PAL	equ	985250*1000
timeconst_pal:
	dc.b	[TIMECONST_PAL>>0]&$ff,[TIMECONST_PAL>>8]&$ff
	dc.b	[TIMECONST_PAL>>16]&$ff,[TIMECONST_PAL>>24]&$ff
TIMECONST_NTSC	equ	1022730*1000
timeconst_ntsc:
	dc.b	[TIMECONST_NTSC>>0]&$ff,[TIMECONST_NTSC>>8]&$ff
	dc.b	[TIMECONST_NTSC>>16]&$ff,[TIMECONST_NTSC>>24]&$ff

pal_flag:
	dc.b	0
timeconst:
	ds.b	4
count:
	ds.b	1
lead:
	ds.b	1
print_time:
; calculate
	lda	#0
	sta	count
	sta	lead
	ldy	#4
	lda	pal_flag
	bne	pt_skp1
	ldy	#4+[timeconst_ntsc-timeconst_pal]
pt_skp1:
	ldx	#4
pt_lp1:
	lda	timeconst_pal-1,y
	sta	timeconst-1,x
	dey
	dex
	bne	pt_lp1
pt_lp2:
	
	ldx	#4
pt_lp3:
	lda	time-1,x
	sta	dividend-1,x
	lda	timeconst-1,x
	sta	divisor-1,x
	dex
	bne	pt_lp3
	jsr	divide

	ldx	#4
	lda	#0
pt_lp4:
	sta	divisor-1,x
	dex
	bne	pt_lp4
	lda	#10
	sta	divisor
	jsr	divide

	lda	count
	cmp	#4
	bne	pt_skp3
	lda	lead
	bne	pt_skp2
	lda	#"0"
	jsr	$ffd2
pt_skp2:
	lda	#"."
	jsr	$ffd2
	sta	lead
pt_skp3:
	lda	lead
	ora	remainder
	beq	pt_skp4
	sta	lead
	lda	remainder
	ora	#$30
	jsr	$ffd2
pt_skp4:

	ldx	#4
pt_lp5:
	lda	timeconst-1,x
	sta	dividend-1,x
	dex
	bne	pt_lp5
	jsr	divide

	ldx	#4
pt_lp6:
	lda	dividend-1,x
	sta	timeconst-1,x
	dex
	bne	pt_lp6

	inc	count
	lda	count
	cmp	#6
	bne	pt_lp2	

	rts

;**************************************************************************
;*
;* NAME  divide
;*
;* DESCRIPTION
;*   32 bit divide
;*   dividend[0-3]=dividend[0-3]/divisor[0-3]
;*   remainder[0-3]=dividend[0-3]%divisor[0-3]
;*   carry set = divide by zero!
;*
;******
divisor:
	ds.b	4
dividend:
	ds.b	4
remainder:
	ds.b	4
divide:
;*
;* Check for zero dividend
;*
	lda	divisor
	ora	divisor+1
	ora	divisor+2
	ora	divisor+3
	sec
	beq	div_fl1		;exit with carry=1 if zero

;*
;* setup remainder
;*
	lda	#0
	sta	remainder
	sta	remainder+1
	sta	remainder+2
	sta	remainder+3

	ldx	#32+1
	clc
	bcc	div_skp1	;ALWAYS!

;*
;* divide loop
;*
div_lp1:
	rol	remainder
	rol	remainder+1
	rol	remainder+2
	rol	remainder+3

;*
;* Does it fit?
;*
	sec
	lda	remainder
	sbc	divisor
	lda	remainder+1
	sbc	divisor+1
	lda	remainder+2
	sbc	divisor+2
	lda	remainder+3
	sbc	divisor+3
	bcc	div_skp1	;no... shift in 

;* yes... subtract
	sec
	lda	remainder
	sbc	divisor
	sta	remainder
	lda	remainder+1
	sbc	divisor+1
	sta	remainder+1
	lda	remainder+2
	sbc	divisor+2
	sta	remainder+2
	lda	remainder+3
	sbc	divisor+3
	sta	remainder+3
div_skp1:
	rol	dividend
	rol	dividend+1
	rol	dividend+2
	rol	dividend+3
	dex
	bne	div_lp1
	clc
div_fl1:
	rts

;**************************************************************************
;*
;* NAME  set_irq_amount
;*
;* DESCRIPTION
;*
;******
set_irq_amount:
	sta	amount
	sei
	lda	#$7f
	sta	$dc0d
	lda	$dc0d
	lda	#$1b
	sta	$d011
	lda	#$00
	sta	$d012
	sta	line
	sta	line+1
	ldx	#<irq
	ldy	#>irq

	lda	amount
	cmp	#$10
	bcc	sia_skp1
	lda	#$18
	sta	$d012
	sta	line
	ldx	#<irq2
	ldy	#>irq2
sia_skp1:
	stx	$0314
	sty	$0315
	lda	amount
	beq	sia_skp2
	lda	#1
sia_skp2:
	sta	$d01a
	sta	$d019
	cli
	rts
amount:
	dc.b	0
line:
	dc.w	0
	
irq:
	sac	$99
	pha
	lda	#3
	sac	$00
	lda	$d020
	pha
	lda	#2
	sta	$d020
	lda	#1
	sta	$d019

	ldx	amount
	ldy	line
i_lp1:	
	cpy	$d012
	beq	i_lp1
	inc	$d020		
	iny
	dex
	bne	i_lp1
	lda	#2
	sta	$d020
		
	lda	line
	clc
	adc	#$10
	sta	line
	bcc	i_skp1
	inc	line+1
i_skp1:

	lda	line+1
	beq	i_skp2
	lda	line
	cmp	#$20
	bcc	i_skp2
	lda	#0
	sta	line
	sta	line+1
i_skp2:
	lda	line
	sta	$d012
	lda	line+1
	lsr
	lda	#$1b<<1
	ror
	sta	$d011

	pla
	sta	$d020
	sac	$99
	pla
	sac	$00
	jmp	$febc	

irq2:
	sac	$99
	pha
	lda	#3
	sac	$00
	lda	$d020
	pha
	lda	#2
	sta	$d020
	lda	#1
	sta	$d019

	ldx	amount
	ldy	line
i2_lp1:	
	cpy	$d012
	beq	i2_lp1
	inc	$d020		
	iny
i2_lp2:	
	cpy	$d012
	beq	i2_lp2
	inc	$d020		
	iny
	dex
	bne	i2_lp1
	lda	#2
	sta	$d020

	pla
	sta	$d020
	sac	$99
	pla
	sac	$00
	jmp	$febc	
	
;**************************************************************************
;*
;* NAME  prepare_system
;*
;* DESCRIPTION
;*   Prepare
;*
;******
prepare_system:	
	php
	sei

	jsr	check_pal
	lda	#0
	rol
	sta	pal_flag

	jsr	wait_vb
; enable extended registers
	lda	#1
	sta	$d03f

; turn off badlines and color fetch
	lda	#%00110000
	sta	$d03c

; replace black with the desired forground
	ldx	646
	lda	$fa56,x
	sta	$d200
	stx	text_color_tmp
	lda	#0
	sta	646
	plp
	rts

text_color_tmp:
	ds.b	1

;**************************************************************************
;*
;* NAME  restore_system
;*
;* DESCRIPTION
;*   Restore
;*
;******
restore_system:
	php
	sei
	jsr	wait_vb
; restore text color and palette
	lda	text_color_tmp
	sta	646
	ldx	#$10
rs_lp1:
	lda	$fa56-1,x
	sta	$d200-1,x
	dex
	bne	rs_lp1

; 	ldx	#%00000000	
	stx	$d03c		; reenable badlines + color fetch
; 	ldx	#0
	stx	$d03f		; exit extended mode
	plp
	rts

;**************************************************************************
;*
;* NAME  wait_vb
;*
;* DESCRIPTION
;*   Restore
;*
;******
wait_vb:
wv_lp1:
	bit	$d011
	bpl	wv_lp1
wv_lp2:
	bit	$d011
	bmi	wv_lp2
	rts

;**************************************************************************
;*
;* NAME  check_pal
;*
;* DESCRIPTION
;*   Check if pal.
;*   C=1 means pal
;*
;*   
;******
check_pal:
;Wait for the negative part of the screen
cp_lp1:
	lda	$d011
	bmi	cp_lp1
cp_lp2:
	lda	$d011
	bpl	cp_lp2
;check for pal
cp_lp3:
	lda	$d012
	cmp	#$20
	beq	cp_ex1		; C=1
	lda	$d011
	bmi	cp_lp3
	clc
cp_ex1:
	rts

;**************************************************************************
;*
;* NAME  copy_runtime
;*
;* DESCRIPTION
;*   Install the runtime at the target address
;*
;******
copy_runtime:
	ldx	#>[RUNTIME_LEN+255]
	ldy	#0
cr_lp1:
cr_sm1:	
	lda	runtime_st,y
cr_sm2:	
	sta	runtime,y
	iny
	bne	cr_lp1
	inc	cr_sm1+2
	inc	cr_sm2+2
	dex
	bne	cr_lp1
	rts

;**************************************************************************
;*
;* SECTION  external code
;*   
;******
runtime_st:
	rorg	$c000
runtime:
	incbin	"loader2_c000_test.prg",2
	rend
RUNTIME_LEN	equ	.-runtime_st
; eof
